/***********************************************************************************************************************
 *
 * blueBill Core - open source birding
 * Copyright (C) 2009-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://bluebill.tidalwave.it
 * SCM: https://kenai.com/hg/bluebill~core-src
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.taxonomy.elmo.impl;

import javax.annotation.Nonnull;
import java.util.ArrayList;
import java.util.List;
import it.tidalwave.bluebill.taxonomy.Finder;
import it.tidalwave.role.Displayable;
import it.tidalwave.util.spi.FinderSupport;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public class ElmoFinder<T extends Displayable> extends FinderSupport<T, ElmoFinder<T>> implements Finder<T> 
  {
    private final static long serialVersionUID = 79876543434689733L;
    
    private String name;
    
    private final List<T> list;
    
    public ElmoFinder (final @Nonnull List<T> list)
      {
        this.list = list;
      }

    @Override
    public ElmoFinder<T> name (final @Nonnull String name)
      {
        final ElmoFinder<T> clone = (ElmoFinder<T>) clone();
        clone.name = name;
        return clone;
      }

    @Override @Nonnull
    protected List<? extends T> computeResults() 
      {
        final List<T> result = new ArrayList<T>();
        
        for (final T object : list)
          {
            if (name.equals(object.getDisplayName()))
              {
                result.add(object);
              }            
          }
        
        return result;
      }
  }
